/***************************************************************************
                          pluginloader.h  -  description
                             -------------------
    begin                : Sun Dec 30 2001
    copyright            : (C) 2001 by Dominik Seichter
    email                : domseichter@web.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGINLOADER_H
#define PLUGINLOADER_H

// Own includes
#include "batchrenamer.h"
#include "plugin.h"

// OS includes
#include <vector>

#include <qdict.h>
#include <klibloader.h>

class KStandardDirs;
class QVBoxLayout;
class QString;
class QWidget;
enum pluginType {
    TYPE_BRACKET,       // Plugin argument is in brackets like [artist] or [1-2]
    TYPE_TOKEN,         // Plugin has its own reserved token like ,& or /
    TYPE_FINAL_FILE     // Plugin does something with the final file
                        // i.e. that is not changing its name but its permission or similar!
};

class PluginLoader {
    public:
        // For RedHat :)
        struct PluginLibrary {
            Plugin *plugin;
            KLibrary *library;
            bool usePlugin;
            bool isActive;
        };

        PluginLoader();
        ~PluginLoader();

        void addDir( QString path );
        QDict<PluginLoader::PluginLibrary> libs;

    private:
        bool loadSO(const QString &spec);
        bool isLoaded(const QString &spec) const;

    protected:
        QWidget* parentWidget;
        KStandardDirs* kstd;
};

#endif
